## libxmlada 17.1.2017

=== unicode/importer/Makefile ===
MAIN := convert
UNICODE_FILES := Blocks.txt NameAliases.txt UnicodeData.txt

.PHONY: all clean ${MAIN}

all: $(MAIN) $(UNICODE_FILES)
	mkdir -p generated
	./$^

$(MAIN):
	gprbuild -p -Pconvert

$(filter-out NameAliases.txt,$(UNICODE_FILES)):
	wget ftp://ftp.unicode.org/Public/8.0.0/ucd/$@
NameAliases.txt:
	wget ftp://ftp.unicode.org/Public/8.0.0/ucd/$@
	patch -p0 < NameAliases.diff

clean:
	rm -f $(UNICODE_FILES)
	gprclean -Pconvert
	rm -rf generated/

=== debian/changelog ===
libxmlada (17.1.2017-5) unstable; urgency=medium

  * Build-Depend latexmk for LaTeX sphinx-doc module. Closes: #872231.
  * Regenerate from unicode version 10. Build-Depend an unicode version
    instead of updating Ada sources with the same -dev package aliversion.
  * Build-Depend: python3 version of sphinx-doc.
  * Forward patches.
  * Standards-Version: 4.1.0.
  * Vcs-Mtn: new monotone URI format.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 25 Sep 2017 10:29:55 +0200

libxmlada (17.1.2017-4) unstable; urgency=medium

  * Upload to unstable.
  * Rename libxmlada-input4.5.2015 -> 4.6, forgotten in last upload.
  * Build-Depends: handle texlive generic package renaming.
  * Standards-Version: 4.0.1 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 09 Aug 2017 18:08:06 +0200

libxmlada (17.1.2017-3) experimental; urgency=medium

  * Rename libxmlada-dom4.5.2015 -> 4.6, reflecting the API and compiler
    changes since last upload to unstable.
  * Disable sphinxdoc parallelism to prevent a FTBFS caused by #869098.
  * Drop Break/Replace: libxmlada-*6-dev, now implicit through gnat-7.
  * Drop Break/Replace: libxmlada-dev, not in oldstable anymore.
  * Debhelper 10. Drop explicit rules targets confusing dh.
  * Handle DEB_BUILD_OPTIONS=nodoc.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 25 Jul 2017 21:52:03 +0200

libxmlada (17.1.2017-2) experimental; urgency=medium

  * Build-Depend: unicode-data >= 9 instead of = 9.
  * Merge changes from gprbuild in shared portion of d/rules.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 02 Jul 2017 20:19:42 +0200

libxmlada (17.1.2017-1) experimental; urgency=medium

  * New upstream release. Build with gnat-7. No ALI/SO bump in experimental.
  * Standards-Version: 4.0.0. Suggest: -doc instead of Recommend.
  * Allow -doc package to satisfy Multi-Arch: foreign dependencies.
  * Move projects to /usr/share/gpr, in gprbuild's upstream lookup path.
  * Output of pdflatex and gnat are now reproducible without help.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 22 Jun 2017 09:33:11 +0200

libxmlada (4.6.2016-1) experimental; urgency=medium

  * New upstream release.
    ALI version of unicode increases, forcing all ALI versions to do so.
    Rename -dev and Break/Replace: previous versions per Ada policy.
    Only sax and schema SO binary interfaces may have changed.
    Since "input_sources" needs to be renamed, use upstream name "input".
  * Upstream drops xmlada-config, remove the related packaging stuff.
  * Apply generate-unicode-names.diff from upstream VCS.
    Exclude generated sources from repackaged orig tarball.
    Update it for unicode version 9 as packaged in Debian.
  * Allow a SO version per library and non existing lib/obj directories.
  * Ensure deterministic timestamps in patched or generated ALI files.
  * README.source: upstream VCS is now on GitHub.
  * Switch watch file to version 4.
  * Reorder build flags to simplify maintenance of PIE flags.
  * Generate internal dependencies instead of copying them manually.
  * tests/link-with-shared depends gprbuild for project support.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 11 Aug 2016 00:56:55 +0200

=== debian/control ===
Source: libxmlada
Priority: optional
Section: libdevel
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
 Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 10),
# dpkg-dev: /usr/share/dpkg/default.mk
 gnat, gnat-7,
# Note: the rules script parses this line to extract the gnat version.
 unicode-data (>= 10~), unicode-data (<< 11~),
# Used by debian/rules to generate unicode-names-*.ads.
# When a new unicode standard is released, we most probably have to
# increase the ALI version of xmlada-unicode and all reverse dependencies.
Build-Depends-Indep: python3-sphinx,
 latexmk,
# Sphinx >= 1.6 uses the latexmk driver.
 texlive-fonts-recommended,
# sphinx-doc requires iftex.sty:
 texlive-plain-generic,
 texlive-latex-extra,
# Sphinx-common provides dh_sphinxdoc.
 sphinx-common
Standards-Version: 4.1.0
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libxmlada
Vcs-Mtn: mtn://www.ada-france.org?org.debian.libxmlada
Homepage: https://libre.adacore.com/libre

Package: libxmlada-unicode7-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: libxmlada-doc
# so all -dev packages indirectly Suggest: -doc.
Description: XML/Ada, a full XML suite for Ada programmers (unicode)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the development tools for the unicode module.

Package: libxmlada-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: gnat
Description: XML/Ada, a full XML suite for Ada programmers (documentation)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the documentation in text, PDF and HTML.

Package: libxmlada-dom7-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: XML/Ada, a full XML suite for Ada programmers (dom)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the development tools for the dom module.

Package: libxmlada-dom4.6
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: XML/Ada, a full XML suite for Ada programmers (dom runtime)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the dom runtime shared library.

Package: libxmlada-input7-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: XML/Ada, a full XML suite for Ada programmers (input sources)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the development tools for the input sources module.

Package: libxmlada-input4.6
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: XML/Ada, a full XML suite for Ada programmers (input sources runtime)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the input sources runtime shared library.

Package: libxmlada-sax7-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: XML/Ada, a full XML suite for Ada programmers (sax)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the development tools for the sax module.

Package: libxmlada-sax4.6.2016
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: XML/Ada, a full XML suite for Ada programmers (sax runtime)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the sax runtime shared library.

Package: libxmlada-schema7-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: XML/Ada, a full XML suite for Ada programmers (schema)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the development tools for the schema module,
 and an xmlada.gpr project importing the whole XML/Ada library.
# inside schema-dev because it Depends: every other -dev package.

Package: libxmlada-schema4.6.2016
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: XML/Ada, a full XML suite for Ada programmers (schema runtime)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the schema runtime shared library.

Package: libxmlada-unicode4.6.2016
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: XML/Ada, a full XML suite for Ada programmers (unicode runtime)
 XML/Ada is a set of modules that provide a simple manipulation of XML
 streams. It supports the whole XML 1.0 specifications, and can parse
 any file that follows this standard (including the contents of the
 DTD).  It also provides support for a number of other standard
 associated with XML, like SAX, DOM, and XML Schemas.  In addition, it
 includes a module to manipulate Unicode streams, since this is required
 by the XML standard.
 .
 This package contains the unicode runtime shared library.

=== debian/rules ===
#!/usr/bin/make -f
# Build script for XML/Ada in Debian.
# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2013-2017 Nicolas Boulenguez <nicolas@debian.org>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.


# NOTE:
# In order to prevent a circular build-dependency, the Debian packages
# for XML/Ada and GPRBuild bother to build without project support.
# Please keep the two debian/rules files similar enough to ease
# backport of good ideas.

######################################################################
# *_DEV_PKG, *_LIB_PKG and *_SONAME are read from the control file.
# To debug, replace eval with error.
$(foreach line,$(shell sed -n ' \
  s/^Package:\s*\(libxmlada-\([a-z]\+\)\([0-9.]\+\)\)$$/ \
    xmlada_\2_LIB_PKG:=\1 \
    xmlada_\2_SONAME:=libxmlada_\2.so.\3 \
   /p;\
  s/^Package:\s*\(libxmlada-\([a-z]\+\)[0-9.]\+-dev\)$$/ \
    xmlada_\2_DEV_PKG:=\1 \
   /p;\
  s/^ gnat, gnat-\([0-9.]\+\),\?$$/ \
    GNAT_VERSION:=\1 \
   /p;\
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk

ADAFLAGS += -gnatafno -gnatVa

# Ignore gnat.adc in top directory.
BUILDER_OPTIONS += -gnatA

######################################################################
%:
	dh $@

# Rewrite upstream configure/make build system.
.PHONY: $(addprefix override_dh_auto_, \
  configure build-arch build-indep test install clean)

# Rewrite upstream targets without gprbuild or gprclean.
# gnatmake does not support projects anymore, we cannot use xmlada.gpr.

######################################################################
# Rewrite unicode/importer/Makefile without network and gprbuild.
obj/shared/$(xmlada_unicode_SONAME) \
obj/static/libxmlada_unicode.a          : unicode/unicode-names-basic_latin.ads

obj/convert: $(wildcard unicode/importer/*.ad[bs]) | obj
	gnatmake unicode/importer/convert.adb -D obj -o $@ \
	  $(BUILDER_OPTIONS) \
	  -cargs $(ADAFLAGS) \
	  -largs $(LDFLAGS)

unicode/unicode-names-basic_latin.ads: obj/convert \
                                       /usr/share/unicode/Blocks.txt \
                                       /usr/share/unicode/NameAliases.txt \
                                       /usr/share/unicode/UnicodeData.txt
 # Generate unicode-names/* directly in unicode/.
	ln -s unicode generated
	$^
	rm generated
override_dh_auto_clean::
	rm -f unicode/unicode-names-*

######################################################################
ADS_DIR := usr/share/ada/adainclude
GPR_DIR := usr/share/gpr
ALI_DIR := usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib
SO_DIR  := usr/lib/$(DEB_HOST_MULTIARCH)
A_DIR   := usr/lib/$(DEB_HOST_MULTIARCH)

define library_template
# Parameters:
# _SRCDIR: directory containing the sources files
# _deps_int       : used in -aI -aO -l for libs built by this deb source
# _deps_int_direct: subset used for .gpr and ada:Depends
# _deps_ext       : used in -aI -aO -l for libs from packaged Build-Depends
# _deps_ext_direct: subset used for .gpr and ada:Depends
# _deps_gnarl     : used in -l, should be empty or gnarl-BV
# For any dependency d, $(d)_DEV_PKG: deb -dev package for $(d)
# For any internal dependency d, $(d)_SRCDIR as above.

  # Remove pure specifications and separate compilation units.
  $(library)_unit_bodies := $(foreach s, \
    $(wildcard $($(library)_SRCDIR)/*.adb) \
    ,$(if $(shell grep -l '^separate ' $(s)),,$(s)))

  $(library)_c_sources := $(wildcard $($(library)_SRCDIR)/*.c)

  # Build dynamic library.
  override_dh_auto_build-arch: obj/shared/$($(library)_SONAME)
  obj/shared/$($(library)_SONAME): \
        $$(patsubst $($(library)_SRCDIR)/%.c,obj/shared_$(library)_obj/%.o,$$($(library)_c_sources)) \
        | obj/shared obj/shared_$(library)_ali obj/shared_$(library)_obj
    # -fPIC/-shared overrides -fPIE/-pie in ADAFLAGS/LDFLAGS.
	gnatmake -c $$($(library)_unit_bodies) -D obj/shared_$(library)_obj \
          $(BUILDER_OPTIONS) \
	  $(foreach l, $($(library)_deps_int), \
	    -aI$($(l)_SRCDIR) \
	    -aOobj/shared_$(l)_ali) \
	  $(addprefix -aI/$(ADS_DIR)/, $($(library)_deps_ext)) \
	  $(addprefix -aO/$(ALI_DIR)/, $($(library)_deps_ext)) \
          -cargs $(ADAFLAGS) -fPIC
	gcc-$(GNAT_VERSION) $(LDFLAGS) -shared \
	  -o $$@ \
	  -Wl,-soname,$($(library)_SONAME) \
	  obj/shared_$(library)_obj/*.o \
	  -Lobj/shared $(addprefix -l, $($(library)_deps_int) \
	                               $($(library)_deps_ext) \
	                               $($(library)_deps_gnarl) \
	                               gnat-$(GNAT_VERSION))
  # Create development link so that the other libraries may link with it.
	ln -fs $($(library)_SONAME) obj/shared/lib$(library).so
  # Move ALI files to library directory and mark them read-only.
	mv obj/shared_$(library)_obj/*.ali obj/shared_$(library)_ali
	chmod 444 obj/shared_$(library)_ali/*

  # Build static library.
  override_dh_auto_build-arch: obj/static/lib$(library).a
  obj/static/lib$(library).a: \
         $(patsubst $($(library)_SRCDIR)/%.c,obj/static_$(library)_obj/%.o,$($(library)_c_sources)) \
        | obj/static obj/static_$(library)_ali obj/static_$(library)_obj
	gnatmake -c $$($(library)_unit_bodies) -D obj/static_$(library)_obj \
          $(BUILDER_OPTIONS) \
	  $(foreach l, $($(library)_deps_int), \
	    -aI$($(l)_SRCDIR) \
	    -aOobj/static_$(l)_ali) \
	  $(addprefix -aI/$(ADS_DIR)/, $($(library)_deps_ext)) \
	  $(addprefix -aO/$(ALI_DIR)/, $($(library)_deps_ext)) \
	  -cargs $(ADAFLAGS)
	ar rc $$@ obj/static_$(library)_obj/*.o
	ranlib $$@
  # Move ALI files to library directory and mark them read-only.
	mv obj/static_$(library)_obj/*.ali obj/static_$(library)_ali
	chmod 444 obj/static_$(library)_ali/*.ali

  obj/shared_$(library)_obj/%.o: $($(library)_SRCDIR)/%.c | obj/shared_$(library)_obj
	gcc-$(GNAT_VERSION) -c $(CFLAGS) $(CPPFLAGS) $$< -o $$@ -fPIC
  obj/static_$(library)_obj/%.o: $($(library)_SRCDIR)/%.c | obj/static_$(library)_obj
	gcc-$(GNAT_VERSION) -c $(CFLAGS) $(CPPFLAGS) $$< -o $$@

  obj/shared_$(library)_ali obj/shared_$(library)_obj obj/static_$(library)_ali obj/static_$(library)_obj: | obj
	mkdir $$@

  override_dh_install::
  # dynamic library
	dh_install --package=$($(library)_LIB_PKG) \
	  obj/shared/$($(library)_SONAME) \
	  $(SO_DIR)
  # static library
	dh_install --package=$($(library)_DEV_PKG) \
	  obj/static/lib$(library).a \
	  $(A_DIR)
  # development symbolic link
	dh_link --package=$($(library)_DEV_PKG) \
	  $(SO_DIR)/$($(library)_SONAME) \
	  $(SO_DIR)/lib$(library).so
  # ALI files
	dh_install --package=$($(library)_DEV_PKG) \
	  obj/shared_$(library)_ali/*.ali \
	  $(ALI_DIR)/$(library)
  # Sources
	dh_install --package=$($(library)_DEV_PKG) \
	  $($(library)_SRCDIR)/*.ad[bs] $$($(library)_c_sources) \
	  $(ADS_DIR)/$(library)
  # Substitution variables for the control file.
	echo 'ada:Depends=gnat, gnat-$(GNAT_VERSION), \
	  $(foreach l, $($(library)_deps_int_direct), $($(l)_DEV_PKG) (=$$$${binary:Version}),) \
	  $(foreach l, $($(library)_deps_ext_direct), $($(l)_DEV_PKG),) \
	  $($(library)_LIB_PKG)' \
	  >> debian/$($(library)_DEV_PKG).substvars

  # Externally built project installed for end users.
  override_dh_auto_build-arch: obj/$(library).gpr
  obj/$(library).gpr: debian/template.gpr | obj
	sed ' \
	  /@IMPORTS@/ { \
	    s//$(foreach l, $($(library)_deps_int_direct) \
	                    $($(library)_deps_ext_direct) \

=== debian/watch ===
version=4

opts=\
  filenamemangle=s/^.*download=//,\
  dversionmangle=s/^.*\.// \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=adacore/xmlada \
.*xmlada-gpl@ANY_VERSION@-src@ARCHIVE_EXT@

# Major and minor versions are set manually, see README.source.

## libxmlada 18

=== debian/changelog ===
libxmlada (18-4) unstable; urgency=medium

  * Update to unicode version 12. Closes: #927943.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 02 May 2019 11:47:15 +0200

libxmlada (18-3) unstable; urgency=medium

  * Update to unicode version 11, really closing #903380.
    The SO and ALI versions are already new in unstable.
  * Standards-Version: 4.2.1. Rules-Requires-Root: no
  * Add some warning to build flags.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 19:30:35 +0200

libxmlada (18-2) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition. Closes: #903380.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:10:06 +0200

libxmlada (18-1) experimental; urgency=medium

  * New upstream release. No package renaming in experimental.
  * Enable parallel doc builds now that #869098 is closed.
  * Remove execution permissions for example sources.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 09 Jun 2018 19:44:04 +0200

libxmlada (17.1.2017-7) experimental; urgency=medium

  * Rebuild with gnat-8.
    Rename shared library and -dev packages per Debian Ada policy.
  * Delete watch file. Explain why in README.source.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 07 May 2018 16:50:15 +0200

libxmlada (17.1.2017-6) unstable; urgency=medium

  * Drop .mtn-ignore, source/lintian-overrides.
    Keeping duplicate information in sync is wasted work.
  * Delete trailing spaces in this changelog.
  * Debhelper 11.
  * Drop obsolete version restriction for dpkg-dev.
  * Standards-Version: 4.1.4.
  * Update upstream homepage URL.
  * Add forgotten sphinxdoc:Build-Using substitution variable.
  * Increase verbosity of run time test.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 03 May 2018 17:16:15 +0200

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,16 @@
 Maintainer: Ludovic Brenta <lbrenta@debian.org>
 Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
  Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 10),
-# dpkg-dev: /usr/share/dpkg/default.mk
- gnat, gnat-7,
+Build-Depends: debhelper (>= 11),
+ gnat, gnat-8,
 # Note: the rules script parses this line to extract the gnat version.
- unicode-data (>= 10~), unicode-data (<< 11~),
+ unicode-data (>= 12~), unicode-data (<< 13~),
 # Used by debian/rules to generate unicode-names-*.ads.
 # When a new unicode standard is released, we most probably have to
 # increase the ALI version of xmlada-unicode and all reverse dependencies.
-Build-Depends-Indep: python3-sphinx,
+Build-Depends-Indep:
+ python3-sphinx (>= 1.6.3-2),
+# fixing #869098.
  latexmk,
 # Sphinx >= 1.6 uses the latexmk driver.
  texlive-fonts-recommended,
@@ -21,12 +22,13 @@
  texlive-latex-extra,
 # Sphinx-common provides dh_sphinxdoc.
  sphinx-common
-Standards-Version: 4.1.0
+Standards-Version: 4.2.1
+Rules-Requires-Root: no
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libxmlada
 Vcs-Mtn: mtn://www.ada-france.org?org.debian.libxmlada
-Homepage: https://libre.adacore.com/libre
-
-Package: libxmlada-unicode7-dev
+Homepage: https://www.adacore.com/community
+
+Package: libxmlada-unicode8-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Suggests: libxmlada-doc
@@ -47,6 +49,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
+Built-Using: ${sphinxdoc:Built-Using}
 Suggests: gnat
 Description: XML/Ada, a full XML suite for Ada programmers (documentation)
  XML/Ada is a set of modules that provide a simple manipulation of XML
@@ -59,7 +62,7 @@
  .
  This package contains the documentation in text, PDF and HTML.
 
-Package: libxmlada-dom7-dev
+Package: libxmlada-dom8-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Description: XML/Ada, a full XML suite for Ada programmers (dom)
@@ -73,7 +76,7 @@
  .
  This package contains the development tools for the dom module.
 
-Package: libxmlada-dom4.6
+Package: libxmlada-dom5
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -90,7 +93,7 @@
  .
  This package contains the dom runtime shared library.
 
-Package: libxmlada-input7-dev
+Package: libxmlada-input8-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Description: XML/Ada, a full XML suite for Ada programmers (input sources)
@@ -104,7 +107,7 @@
  .
  This package contains the development tools for the input sources module.
 
-Package: libxmlada-input4.6
+Package: libxmlada-input5
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -121,7 +124,7 @@
  .
  This package contains the input sources runtime shared library.
 
-Package: libxmlada-sax7-dev
+Package: libxmlada-sax8-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Description: XML/Ada, a full XML suite for Ada programmers (sax)
@@ -135,7 +138,7 @@
  .
  This package contains the development tools for the sax module.
 
-Package: libxmlada-sax4.6.2016
+Package: libxmlada-sax5
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -152,7 +155,7 @@
  .
  This package contains the sax runtime shared library.
 
-Package: libxmlada-schema7-dev
+Package: libxmlada-schema8-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Description: XML/Ada, a full XML suite for Ada programmers (schema)
@@ -168,7 +171,7 @@
  and an xmlada.gpr project importing the whole XML/Ada library.
 # inside schema-dev because it Depends: every other -dev package.
 
-Package: libxmlada-schema4.6.2016
+Package: libxmlada-schema5
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -185,7 +188,7 @@
  .
  This package contains the schema runtime shared library.
 
-Package: libxmlada-unicode4.6.2016
+Package: libxmlada-unicode5
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 # Build script for XML/Ada in Debian.
 # Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
-# Copyright (c) 2013-2017 Nicolas Boulenguez <nicolas@debian.org>
+# Copyright (c) 2013-2018 Nicolas Boulenguez <nicolas@debian.org>
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -40,10 +40,14 @@
   ' debian/control),$(eval $(line)))
 
 DEB_BUILD_MAINT_OPTIONS := hardening=+all
+DEB_ADAFLAGS_MAINT_APPEND := -gnatwa -Wall -gnatafno -gnatVa
+DEB_LDFLAGS_MAINT_APPEND := \
+  -Wl,--as-needed \
+  -Wl,--no-undefined \
+  -Wl,--no-copy-dt-needed-entries \
+  -Wl,--no-allow-shlib-undefined
 include /usr/share/dpkg/default.mk
 include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk
-
-ADAFLAGS += -gnatafno -gnatVa
 
 # Ignore gnat.adc in top directory.
 BUILDER_OPTIONS += -gnatA
@@ -191,8 +195,3 @@
 
   # Externally built project installed for end users.
   override_dh_auto_build-arch: obj/$(library).gpr
-  obj/$(library).gpr: debian/template.gpr | obj
-	sed ' \
-	  /@IMPORTS@/ { \
-	    s//$(foreach l, $($(library)_deps_int_direct) \
-	                    $($(library)_deps_ext_direct) \

## libxmlada 19

=== tests/Makefile ===
TESTS= test_unicode \
		 test_state \
		 test_xml \
		 test_adacore_dom \
		 test_schema \
		 test_date_time \
		 test_numbers \
		 test_adacore_schema \
		 test_multiple_xsd \
		 test_examples_dom \
		 test_examples_sax \
		 test_examples_schema


# Force running all the tests
.PHONY: ${TESTS}

tests: ${TESTS}

EXECDIR=./obj/
RESULTS=$(shell pwd)/results
EXAMPLE_EXPECTED=$(shell pwd)/examples

test_unicode: EXEC=unicode/test_unicode
test_unicode: generic_test_unicode

test_state: EXEC=sax/teststate
test_state: generic_test_state

test_xml: EXEC=dom/testxml
test_xml: ARGS=-auto
test_xml: generic_test_xml

test_schema: EXEC=schema/schematest
test_schema: ARGS=--xsd10
test_schema: generic_test_schema

test_date_time: EXEC=schema/test_date_time
test_date_time: generic_test_date_time

test_numbers: EXEC=schema/testnumbers
test_numbers: generic_test_numbers

test_adacore_dom: EXEC=adacore/dom/adacore_dom.sh
test_adacore_dom: EXECDIR=./

test_adacore_schema: EXEC=adacore/schema/adacore_schema.sh
test_adacore_schema: EXECDIR=./

ifneq ($(wildcard adacore/.*),)
test_adacore_dom: generic_test_adacore_dom
test_adacore_schema: generic_test_adacore_schema
else
test_adacore_dom: generic_not_run_adacore_dom
test_adacore_schema: generic_not_run_adacore_schema
endif

generic_test_%: BASE=$(notdir $(EXEC))
generic_test_%: DIR=$(dir $(EXEC))
generic_test_%:
	@echo "$(EXEC)"
	@cd $(DIR); \
		mkdir -p obj; \
		$(EXECDIR)$(BASE) $(ARGS) > obj/$(BASE).tmp_out; \
		tr -d '\r' < obj/$(BASE).tmp_out > $(RESULTS)/$(BASE).out ; \
		diff $(BASE).expected $(RESULTS)/$(BASE).out > $(RESULTS)/$(BASE).diff; \
	  	if test -s $(RESULTS)/$(BASE).diff; then \
		   echo "DIFF"; \
			cat $(RESULTS)/$(BASE).diff ; \
		else \
		   echo "OK"; \
		fi

generic_not_run_%:
	@echo "$(EXEC) skipped"

test_multiple_xsd:
	@echo "multiple xsd"
	@cd schema/multiple_xsd; \
		gprbuild -q -Pdefault.gpr; \
		./validate > $(RESULTS)/multiple_xsd.out; \
		cp $(RESULTS)/multiple_xsd.out $(RESULTS)/multiple_xsd.diff; \
		cat $(RESULTS)/multiple_xsd.diff

test_examples_dom:
	@echo "test examples dom"
	@cd ../docs/dom; \
		gprbuild -q -p -Pdefault.gpr 2> $(RESULTS)/domexample.out; \
		./domexample >> $(RESULTS)/domexample.out; \
		cp $(RESULTS)/domexample.out $(RESULTS)/domexample.diff; \
		cat $(RESULTS)/domexample.diff; \
		./domexample2 > $(RESULTS)/domexample2.out; \
		diff -b $(EXAMPLE_EXPECTED)/domexample2.expected $(RESULTS)/domexample2.out > $(RESULTS)/domexample2.diff; \
		if test -s $(RESULTS)/domexample2.diff; then \
			cat $(RESULTS)/domexample2.diff; fi; \
		./domschemaexample > $(RESULTS)/domschemaexample.out; \
		cp $(RESULTS)/domschemaexample.out $(RESULTS)/domschemaexample.diff; \
		cat $(RESULTS)/domschemaexample.diff

test_examples_sax:
	@echo "test examples sax"
	@cd ../docs/sax; \
		gprbuild -q -p -Pdefault.gpr 2> $(RESULTS)/saxexample_main.out; \
		./saxexample_main >> $(RESULTS)/saxexample_main.out; \
		diff -b $(EXAMPLE_EXPECTED)/saxexample_main.expected $(RESULTS)/saxexample_main.out > $(RESULTS)/saxexample_main.diff; \
		if test -s $(RESULTS)/saxexample_main.diff; then \
			cat $(RESULTS)/saxexample_main.diff; \
		fi

test_examples_schema:
	@echo "test examples schema"
	@cd ../docs/schema; \
		gprbuild -q -p -Pdefault.gpr 2> $(RESULTS)/schemaexample.out; \
		./schemaexample >> $(RESULTS)/schemaexample.out; \
		cp $(RESULTS)/schemaexample.out $(RESULTS)/schemaexample.diff; \
		cat $(RESULTS)/schemaexample.diff

=== debian/changelog ===
libxmlada (19-3) unstable; urgency=medium

  * Update for unicode 13. Closes: #954130.
    The changes affect niche packages, so I am keeping the ALI version.
  * Move gnat and unicode-data from Build-Depends to Build-Depends-Arch.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 25 Mar 2020 16:16:24 +0100

libxmlada (19-2) unstable; urgency=medium

  * Reupload to unstable for gnat-9 transition.
  * Drop --as-needed, enabled by default with gcc-9.
  * Only include used dpkg Makefile snippets.
  * Debhelper 12 does not compress examples anymore.
  * Reduce divergence with part of d/rules shared with gprbuild.
  * Remove redundant branch from Vcs-Git field.
  * Standards-Version: 4.5.0.
  * Use dh-sequence debhelper syntax for sphinxdoc.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 23 Feb 2020 17:51:37 +0100

libxmlada (19-1) experimental; urgency=medium

  * New upstream release, built with gnat-9.
    Migration in experimental, renaming lib and -dev packages.
  * Move Version Control System to salsa.
  * Refresh forwarded patches.
  * Debhelper 12.
  * Standards-version 4.4.0.
  * Update Source URL in d/copyright.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 18 Jul 2019 11:18:48 +0200

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,17 @@
 Maintainer: Ludovic Brenta <lbrenta@debian.org>
 Uploaders: Xavier Grave <xavier.grave@csnsm.in2p3.fr>,
  Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: debhelper (>= 11),
- gnat, gnat-8,
+Build-Depends:
+ debhelper-compat (= 12),
+Build-Depends-Arch:
+ gnat, gnat-9,
 # Note: the rules script parses this line to extract the gnat version.
- unicode-data (>= 12~), unicode-data (<< 13~),
+ unicode-data (>= 13~), unicode-data (<< 14~),
 # Used by debian/rules to generate unicode-names-*.ads.
 # When a new unicode standard is released, we most probably have to
 # increase the ALI version of xmlada-unicode and all reverse dependencies.
 Build-Depends-Indep:
+ dh-sequence-sphinxdoc,
  python3-sphinx (>= 1.6.3-2),
 # fixing #869098.
  latexmk,
@@ -20,15 +23,13 @@
 # sphinx-doc requires iftex.sty:
  texlive-plain-generic,
  texlive-latex-extra,
-# Sphinx-common provides dh_sphinxdoc.
- sphinx-common
-Standards-Version: 4.2.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
-Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libxmlada
-Vcs-Mtn: mtn://www.ada-france.org?org.debian.libxmlada
+Vcs-Browser: https://salsa.debian.org/debian/libxmlada
+Vcs-Git: https://salsa.debian.org/debian/libxmlada.git
 Homepage: https://www.adacore.com/community
 
-Package: libxmlada-unicode8-dev
+Package: libxmlada-unicode9-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Suggests: libxmlada-doc
@@ -62,7 +63,7 @@
  .
  This package contains the documentation in text, PDF and HTML.
 
-Package: libxmlada-dom8-dev
+Package: libxmlada-dom9-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Description: XML/Ada, a full XML suite for Ada programmers (dom)
@@ -76,7 +77,7 @@
  .
  This package contains the development tools for the dom module.
 
-Package: libxmlada-dom5
+Package: libxmlada-dom6
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -93,7 +94,7 @@
  .
  This package contains the dom runtime shared library.
 
-Package: libxmlada-input8-dev
+Package: libxmlada-input9-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Description: XML/Ada, a full XML suite for Ada programmers (input sources)
@@ -107,7 +108,7 @@
  .
  This package contains the development tools for the input sources module.
 
-Package: libxmlada-input5
+Package: libxmlada-input6
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -124,7 +125,7 @@
  .
  This package contains the input sources runtime shared library.
 
-Package: libxmlada-sax8-dev
+Package: libxmlada-sax9-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Description: XML/Ada, a full XML suite for Ada programmers (sax)
@@ -138,7 +139,7 @@
  .
  This package contains the development tools for the sax module.
 
-Package: libxmlada-sax5
+Package: libxmlada-sax6
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -155,7 +156,7 @@
  .
  This package contains the sax runtime shared library.
 
-Package: libxmlada-schema8-dev
+Package: libxmlada-schema9-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Description: XML/Ada, a full XML suite for Ada programmers (schema)
@@ -171,7 +172,7 @@
  and an xmlada.gpr project importing the whole XML/Ada library.
 # inside schema-dev because it Depends: every other -dev package.
 
-Package: libxmlada-schema5
+Package: libxmlada-schema6
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -188,7 +189,7 @@
  .
  This package contains the schema runtime shared library.
 
-Package: libxmlada-unicode5
+Package: libxmlada-unicode6
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 # Build script for XML/Ada in Debian.
 # Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
-# Copyright (c) 2013-2018 Nicolas Boulenguez <nicolas@debian.org>
+# Copyright (c) 2013-2019 Nicolas Boulenguez <nicolas@debian.org>
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,7 +24,7 @@
 # backport of good ideas.
 
 ######################################################################
-# *_DEV_PKG, *_LIB_PKG and *_SONAME are read from the control file.
+# Read some variables from the Debian control file.
 # To debug, replace eval with error.
 $(foreach line,$(shell sed -n ' \
   s/^Package:\s*\(libxmlada-\([a-z]\+\)\([0-9.]\+\)\)$$/ \
@@ -42,12 +42,15 @@
 DEB_BUILD_MAINT_OPTIONS := hardening=+all
 DEB_ADAFLAGS_MAINT_APPEND := -gnatwa -Wall -gnatafno -gnatVa
 DEB_LDFLAGS_MAINT_APPEND := \
-  -Wl,--as-needed \
   -Wl,--no-undefined \
   -Wl,--no-copy-dt-needed-entries \
   -Wl,--no-allow-shlib-undefined
-include /usr/share/dpkg/default.mk
-include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk
+include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/buildflags.mk
+ifneq (,$(wildcard /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk))
+  # In Build-Depends-Arch but not -Indep.
+  include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk
+endif
 
 # Ignore gnat.adc in top directory.
 BUILDER_OPTIONS += -gnatA
@@ -95,6 +98,7 @@
 define library_template
 # Parameters:
 # _SRCDIR: directory containing the sources files
+# _SONAME : shared object name (libNAME.so.VERSION)
 # _deps_int       : used in -aI -aO -l for libs built by this deb source
 # _deps_int_direct: subset used for .gpr and ada:Depends
 # _deps_ext       : used in -aI -aO -l for libs from packaged Build-Depends
@@ -190,8 +194,3 @@
 	echo 'ada:Depends=gnat, gnat-$(GNAT_VERSION), \
 	  $(foreach l, $($(library)_deps_int_direct), $($(l)_DEV_PKG) (=$$$${binary:Version}),) \
 	  $(foreach l, $($(library)_deps_ext_direct), $($(l)_DEV_PKG),) \
-	  $($(library)_LIB_PKG)' \
-	  >> debian/$($(library)_DEV_PKG).substvars
-
-  # Externally built project installed for end users.
-  override_dh_auto_build-arch: obj/$(library).gpr
